/*
 * dukHelper.h
 *
 *  Created on: Jun 26, 2017
 *      Author: vagner
 */

#pragma once

#include <regex.h>
#include <string>
#include <vector>

#include "duktape.h"

namespace vCommon
{

	class dukHelper
	{
	private:
		duk_context* ctx;
		regex_t reg;
		//
		//	Безопасное вычисление выражения.
		//
		static duk_ret_t save_eval ( duk_context *ctx, void *udata );
		//
		//	Безопасное преобразование результата к строке.
		//
		static duk_ret_t save_tostring ( duk_context *ctx, void *udata );
	public:
		//
		//	ctor
		//
		dukHelper ( );
		//
		//	dtor
		//
		~dukHelper ( );
		//
		//	Вычислить выражение.
		//
		bool eval ( const std::string& expr );
		//
		//	Показать результат выражения.
		//
		std::string show ( const std::string& expr );
		//
		//	Получить список идентификаторов в выражении.
		//
		std::vector <std::string> getIdList ( const std::string& expr );
	};

} /* namespace vCommon */
