//
//	vtime.h
//
//	Автор	:	vagner
//	Создан	:	Sep 26, 2019
//

#pragma once

#include <string>

#include "vdef.h"

namespace vCommon
{
	//-----------------------------------------------------------------------------
	//
	class vtime
	{
	private:

		//	класс "активизирован"
		static bool _IsActivated;

		//	смещение относительно монотонного времени
		static i64 mono_offset;

		//	часовой пояс (сек)
		static i32 time_zone;

		//	активизировать класс значениями по умолчанию
		static void Activate ( );

	public:

		//	активизировать класс
		static void Activate ( i64 _mono_offset, i32 _time_zone );

		//	активизировать класс
		static void Activate ( std::string &payload );

		//	IsActivated
		static inline bool IsActivated ( )
		{
			return _IsActivated;
		}

		//	текущее монотонное время
		static i64 mono ( );

		//	миллисекунды (получены от монотонного времени)
		static i64 ms ( );

		//	текущее время - локальное
		static i64 local_time ( );

		//	текущее время - UTC
		static i64 time ( );
	};
} /* namespace vCommon */
