/*
 * mqMsg.h
 *
 *  Created on: Feb 21, 2017
 *      Author: vagner
 */

#pragma once

#include <mosquitto.h>
#include <string>

#include <SyncVector.h>

namespace vMQ
{
	class mqMsg : public vCommon::svMessage
	{
	public:
		std::string topic;	    //	топик
		std::string payload;    //  содержимое сообщения
		int qos;			    //	качество сервиса (QoS)
		int retain;             //  оставить сообщение в очереди после прочтения
		int msgId;              //  идентификатор сообщения
		//
		//	ctor
		//
		mqMsg ( int OpCode, const std::string& topic, const std::string& payload, int qos = 2, int retain = false );
		//
		//	ctor
		//
		mqMsg ( int OpCode, const mosquitto_message* msg );
		//
		//	dtor
		//
		virtual ~mqMsg ( ) { }
	};

} /* namespace vMQ */
